<template>
  <div>
    <v-dialog v-model="mostrarmensaje" persistent max-width="600">
      <v-card>
        <div class="gris">
          <div class="btnCerrarModal" @click="cancelarAlerta">
            <div>X</div>
          </div>
          <div id="tam">
            <div class="titSec">¡Envío exitoso!</div>
            <br />
            <v-row>
              <v-col :cols="12" :sm="12" :md="1" :lg="1" :xl="1"></v-col>
              <v-col :cols="12" :sm="12" :md="10" :lg="10" :xl="10">
                Los documentos se han enviado correctamente a todos los
                contactos seleccionados.
              </v-col>
            </v-row>
          </div>
        </div>
      </v-card>
    </v-dialog>
    <SelecionaFechas :value="fechas"></SelecionaFechas>
    <DatosCorreoEnviar
      :correosOP="correosOP"
      :correosOC="correosOC"
      :asunto="asunto"
      :key="datosKey"
    ></DatosCorreoEnviar>
    <v-row>
      <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="5"></v-col>
      <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
        <button class="btn" @click="enviarCorreo">Enviar</button>
      </v-col>
    </v-row>
  </div>
</template>
<style scoped>
#tam {
  max-height: 110px;
  min-height: 110px;
}
</style>
<script>
import moment from "moment";
import store from "@/store";
const axios = store.state.axiosApiLocal;
import SelecionaFechas from "@/views/secure/infraestructura/visualizador-documentos/componentes2/SelecionaFechas.vue";
import DatosCorreoEnviar from "@/views/secure/infraestructura/visualizador-documentos/componentes2/DatosCorreoEnviar";
export default {
  components: {
    SelecionaFechas,
    DatosCorreoEnviar,
  },
  name: "envios_documentos_correo",
  data() {
    return {
      mostrarmensaje: false,
      datosKey: 0,
      correoDestinatario: "",
      correosCopiados: [],
      fechas: {
        fechaI: "",
        fechaF: "",
      },
      correosOP: {
        correos: [],
      },
      correosOC: {
        correos: ["CC"],
      },
      asunto: {
        asunto: "",
      },
    };
  },
  watch: {
    "fechas.fechaI"(val) {
      this.asunto.asunto =
        "Resumen de Carga de Layouts del día " +
        this.fechaAsunto(this.fechas.fechaI) +
        " al día " +
        this.fechaAsunto(this.fechas.fechaF);
    },
    "fechas.fechaF"(val) {
      this.asunto.asunto =
        "Resumen de Carga de Layouts del día " +
        this.fechaAsunto(this.fechas.fechaI) +
        " al día " +
        this.fechaAsunto(this.fechas.fechaF);
    },
  },
  methods: {
    fechaAsunto(date) {
      let fecha = moment(date).format("DD/MM/YY");
      if (fecha != "Invalid date") {
        return fecha;
      } else {
        return "";
      }
    },
    cancelarAlerta() {
      this.mostrarmensaje = false;
    },
    upDateComponents() {
      this.datosKey += 1;
      this.fechas.fechaI = "";
      this.fechas.fechaF = "";
      this.asunto.asunto = "";
      this.correoDestinatario = "";
      this.correosCopiados = [];
    },
    getDestinatario() {
      this.correosOP.correos.forEach((element) => {
        if (this.validEmail(element) && this.correoDestinatario == "") {
          this.correoDestinatario = element;
        } else if (this.validEmail(element)) {
          this.correosCopiados.push(element);
        }
      });
    },
    getCopiados() {
      this.correosOC.correos.forEach((element) => {
        if (this.validEmail(element)) {
          this.correosCopiados.push(element);
        }
      });
    },
    formatDate(date) {
      return moment(date).format("DDMMYY");
    },
    validEmail(email) {
      var re =
        /^[a-zA-Z0-9.!#$%&’*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/;
      return re.test(email);
    },
    enviarCorreo() {
      this.correoDestinatario = "";
      this.correosCopiados = [];
      this.getDestinatario();
      this.getCopiados();
      if (
        this.fechas.fechaF != "" &&
        this.fechas.fechaI != "" &&
        this.correoDestinatario != ""
      ) {
        axios
          .post("/envia-correo/layouts/alta-semanal/correo/envio/", {
            asunto: this.asunto.asunto,
            contactosCopiados: this.correosOC.correos,
            destinatario: this.correosOP.correos[0],
            fechaFinalReporte: this.formatDate(this.fechas.fechaF),
            fechaInicialReporte: this.formatDate(this.fechas.fechaI),
          })
          .then((response) => {
            let data = response.data;
            if (data) {
              console.log("EnvioExitoso");
              this.mostrarmensaje = true;
              this.upDateComponents();
            }
          })
          .catch((error) => {
            if (error.response) {
              console.log(error.response.data);
            }
          });
      }
    },
  },
};
</script>